/*----------------------------------------------------------------------------------------------------
	TOMGS - ANCHORED ROLLOVER IMAGE ENGINE v2.0
		by Tomohito Higuchi (http://www.tom-gs.com/)
	<FEATURES>
		1. You do not need to write 'onMouseover' and 'onMouseout' attributes in HTML tags.
		2. You just write your setting for rollover images in this JavaScript file.
		3. Current page activation makes your pages gentle for ones who see it.
	<USAGE>
		1. First you must understand structures of html tag for this engine. This engine needs id
			attribute in tag, plus, the images must be sandwiched by anchor tags.
				<ul id="sample_menu">
					<li><a href="./menu1.htm"><img src="./images/menu1_0.gif" width="100" height="20" /></a></li>
					<li><a href="./menu2.htm"><img src="./images/menu2_0.gif" width="100" height="20" /></a></li>
					<li><a href="./menu3.htm"><img src="./images/menu3_0.gif" width="100" height="20" /></a></li>
				</ul>
			Please write the statements like upper example on your html.
			
		2. Next you must set configuration on this file. You should set values of variables
			in lines 'config' commented.
				targetId: ID attribute of html tag (ex. targetId = "sample_menu";)
				prefixPath: Path to images for rollover (ex. prefixPath = "./images/";)
				outImages: Image file names when mouse pointer is out
					(ex. outImages = new Array("menu1_0.gif", "menu2_0.gif", "menu3_0.gif");)
				overImages: Image file names when mouse pointer is over
					(ex. overImages = new Array("menu1_1.gif", "menu2_1.gif", "menu3_1.gif");)
				curPgImages: Image file names when that page is open.
							This image does not reverse on mouseover and mouseout.
					(ex. overImages = new Array("menu1_2.gif", "menu2_2.gif", "menu3_2.gif");)
			
			ATTENTION!: Check again outImages, overImages and curPgImages.
						Those must have the same orders.
						
		3. You must set two flags named 'curPgActivation' and 'enableCurAnchor'.
			curPgActivation	(Current Page Activation)
				VALUES: <enable> YES, yes, 1	<disable> NO, no, 0
				This flag means that the page that the rollover image is refering is being shown,
				the image is changed to one of curPgImages you set. After all, the changed image
				will mean the name or category of the page.
			enableCurAnchor (Enable Current page Anchor)
				VALUES: <enable> YES, yes, 1	<disable> NO, no, 0
				This flag means that page that the changed image is able to be clicked with anchor
				tag. This function is not usable if the curPgActivation is disabled.
----------------------------------------------------------------------------------------------------*/

//== config ==========================================================================================
  targetId    = "sb_list";
  prefixPath  = "./images/";
  outImages   = new Array("sb_about_0.gif", "sb_toppage_0.gif", "sb_menu_0.gif", "sb_contact_0.gif");
  overImages  = new Array("sb_about_1.gif", "sb_toppage_1.gif", "sb_menu_1.gif", "sb_contact_1.gif");
  curPgImages = new Array("sb_about_2.gif", "sb_toppage_2.gif", "sb_menu_2.gif", "sb_contact_2.gif");
  curPgActivation = "YES";
  enableCurAnchor = "YES";
//====================================================================================================


//CATCH onload EVENT
//BY EVENT LISTENER BECAUSE TO ESCAPE TH COLLISION OF ONLOAD EVENTS
if (navigator.appName == "Microsoft Internet Explorer"){
	window.attachEvent("onload", startFunctions);
}else{
	window.addEventListener("load", startFunctions, false);
}

//FUNCTION TO START FUNCTIONS
function startFunctions(){
	startRollover();
	if (curPgActivation == "YES" || curPgActivation == "yes" || curPgActivation == "1"){
		currentReverse();
	}
}

//FUNCTION: ROLLOVER IMAGE ENGINE
function startRollover(){
	var targetObj = document.getElementById(targetId);
	if (navigator.appName == "Microsoft Internet Explorer"){
		ie(targetObj);
	}else{
		notIe(targetObj);
	}
}

//Check origin of events on IE
function ie(targetObj){
	targetObj.attachEvent("onmouseover", imgChange);
	targetObj.attachEvent("onmouseout", imgChange);
}

//Check origin of event on non IE
function notIe(targetObj){
	targetObj.addEventListener("mouseover", imgChange, false);
	targetObj.addEventListener("mouseout", imgChange, false);
}


//Changing image
function imgChange(evt) {
	var anchorElements = document.getElementById(targetId).getElementsByTagName("a");
	for (var i = 0; i < anchorElements.length; i++){
		var imgObj = anchorElements[i].firstChild;
		var eventObj;
		if (navigator.appName == "Microsoft Internet Explorer"){
			eventObj = event.srcElement;
		}else{
			eventObj = evt.target;
		}
		if (imgObj == eventObj){
			var fileName  = getName(imgObj);
			imgObj.src = prefixPath + fileName;
		}
	}
}

//Getting name of image
function getName(imgObj){
	var pos = imgObj.src.lastIndexOf("/");
	if (pos != -1){
		pos++;
		var fileName = imgObj.src.substring(pos);
	}
	
	for (var i = 0; i < outImages.length; i++){
		if (fileName == outImages[i]){
			return overImages[i];
		}else if (fileName == overImages[i]){
			return outImages[i];
		}else if (fileName == curPgImages[i]){
			curFlag = 1;
			return curPgImages[i];
		}
	}
}

//FUNCTION: GET INDEX OF ARRAY
function getNum(imgObj){
	var pos = imgObj.src.lastIndexOf("/");
	if (pos != -1){
		pos++;
		var fileName = imgObj.src.substring(pos);
	}
	
	for (var i = 0; i < outImages.length; i++){
		if (fileName == outImages[i]){
			return i;
		}
	}
}

//FUNCTION: IMAGE REVERSING MAIN PROCESS
function currentReverse(){
	var url = document.URL;
	var page = url.substring(url.lastIndexOf("/") + 1, url.length);
	if (page.indexOf("?") != -1){
		var stNum = 0;
		if (page.charAt(0) == "/"){
			stNum = 1;
		}
		page = page.substring(stNum, page.indexOf("?"));
	}
	var anchorElements = document.getElementById(targetId).getElementsByTagName("a");
	for (var i = 0; i < anchorElements.length; i++){
		var aHref = anchorElements[i].attributes.getNamedItem("href").value;
		var pageRe = new RegExp(page, "i");
		var num = getNum(anchorElements[i].firstChild);
		if (aHref.match(pageRe)){
			if (enableCurAnchor == "YES" || enableCurAnchor == "yes" || enableCurAnchor == "1"){
				var imgObjElement = anchorElements[i].firstChild;
				imgObjElement.src = prefixPath + curPgImages[num];
				var parentElement = anchorElements[i].parentNode;
				parentElement.removeChild(anchorElements[i]);
				if (parentElement == document.getElementById(targetId)){
					if (i == (anchorElements.length)){
						parentElement.appendChild(imgObjElement);
					}else{
						document.getElementById(targetId).insertBefore(imgObjElement, anchorElements[i]);
					}
				}else{
					parentElement.appendChild(imgObjElement);
				}
			}else{
				anchorElements[i].firstChild.src = prefixPath + curPgImages[num];
			}
			break;
		}
	}
}
